"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.esbuildAliasPathPlugin = void 0;
// TODO: tsconfig-paths intergration
const esbuildAliasPathPlugin = (options = {}) => {
    var _a;
    const aliases = (_a = options.aliases) !== null && _a !== void 0 ? _a : {};
    const aliasKeys = Object.keys(aliases);
    const escapedNamespace = new RegExp(`^${aliasKeys
        .map((str) => str.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'))
        .join('|')}$`);
    return {
        name: 'alias-path',
        setup(build) {
            build.onResolve({ filter: escapedNamespace }, (args) => {
                var _a;
                return {
                    // if no matched...
                    path: (_a = aliases[args.path]) !== null && _a !== void 0 ? _a : args.path,
                };
            });
            if (Array.isArray(aliases)) {
                aliases.forEach((alias) => {
                    build.onResolve({ filter: new RegExp(alias.from) }, (args) => {
                        var _a;
                        return {
                            // if no matched...
                            path: (_a = alias.to) !== null && _a !== void 0 ? _a : args.path,
                        };
                    });
                });
            }
        },
    };
};
exports.esbuildAliasPathPlugin = esbuildAliasPathPlugin;
//# sourceMappingURL=index.js.map